      !***********************************************************************!
      SUBROUTINE  nrmerr(  gnrm2,  gnrmoo,  u,  u_exact,  tps  )
      !***********************************************************************!
!
      USE numerics
!
      IMPLICIT  NONE
!
      INTERFACE
!
      INCLUDE    'i_fctut.h'
!
      END INTERFACE
!Solution  u  a  l'instant tps
      REAL(rp),  DIMENSION(  sx-1:ex+1,  sy-1:ey+1,  sz-1:ez+1),  INTENT(IN)  ::  u
!
!Solution exacte
      REAL(rp),  DIMENSION(  sx-1:ex+1,  sy-1:ey+1,  sz-1:ez+1),  INTENT(IN)  ::  u_exact
!
!Norme L2,   solution et erreur
      REAL(rp),  DIMENSION(2),  INTENT(OUT)  ::  gnrm2
!
!Norme Loo,  solution et erreur
      REAL(rp),  DIMENSION(2),  INTENT(OUT)  ::  gnrmoo
!
!Instant courant
      REAL(rp),  INTENT(IN)   ::  tps
!
!--Declaration des variales locales
!
!Composante temporelle
      REAL(rp)  ::  ut
!
!Compteurs
      INTEGER   ::  i,  j,  k
!
      !***********************************************************************!
!
      CALL fctut( tps, ut )
!
!Calcul des quantites L2 et Loo
!$OMP DO REDUCTION( +:gnrm2 ), REDUCTION( MAX:gnrmoo )
      DO  k  =  sz,  ez
         DO  j  =  sy,  ey
            DO  i  =  sx,  ex
               gnrm2(1)  = gnrm2(1) + u(i,j,k)**2
               gnrm2(2)  = gnrm2(2) + ( u(i,j,k) - ut * u_exact(i,j,k) ) **2
               gnrmoo(1) = MAX( gnrmoo(1), ABS( u(i,j,k) ) )
               gnrmoo(2) = MAX( gnrmoo(2), ABS( u(i,j,k) - ut * u_exact(i,j,k) ) )
            END  DO
         END  DO
      END  DO
!$OMP END DO
!
!$OMP MASTER
      gnrm2(1:2) = SQRT( gnrm2(1:2) / ( REAL(ntx, rp) * REAL(nty, rp) * REAL(ntz, rp ) ) )
!$OMP END MASTER
!
      RETURN
      END  SUBROUTINE  nrmerr
