      !***********************************************************************!
      SUBROUTINE  u_comm(  u, utabN, utabE, utabS, utabW, utabAV, utabAR, voisin  )
      !***********************************************************************!
!
! Mise des interfaces du tableau u
!
      USE numerics
!
      IMPLICIT  NONE
!
      INCLUDE 'comthd.h'
!
      INCLUDE 'u_comptr.h'
!
!--Declaration des arguments
!
!Solution u
      REAL(rp),  DIMENSION(sx-1:ex+1,sy-1:ey+1,sz-1:ez+1),  INTENT(INOUT)  ::  u
!
!Buffers locaux de donnees
      REAL(rp),  DIMENSION(sy:ey,sz:ez),  INTENT(OUT)  ::  utabE
      REAL(rp),  DIMENSION(sy:ey,sz:ez),  INTENT(OUT)  ::  utabW
      REAL(rp),  DIMENSION(sx:ex,sz:ez),  INTENT(OUT)  ::  utabS
      REAL(rp),  DIMENSION(sx:ex,sz:ez),  INTENT(OUT)  ::  utabN
      REAL(rp),  DIMENSION(sx:ex,sy:ey),  INTENT(OUT)  ::  utabAV
      REAL(rp),  DIMENSION(sx:ex,sy:ey),  INTENT(OUT)  ::  utabAR
!
!Tableau  contenant  les  voisins  du  domaine  courant
      INTEGER,  PARAMETER  ::  NB_VOISINS  =  6
      INTEGER,  PARAMETER  ::  N=1,  E=2,  S=3,  W=4,  AV=5,  AR=6
      INTEGER,  DIMENSION(NB_VOISINS),  INTENT(IN)  ::  voisin
!
!--Declaration des variales locales
!
!Compteurs
      INTEGER  ::  i, j, k
!
      !***********************************************************************!
!
!Preparation des buffers
!
      IF( voisin(N) /= -1 ) THEN
!
         DO k = sz, ez
            DO i = sx, ex
               utabN(i,k) = u(i,ey,k)
            END DO
         END DO
!
      END IF
!
!Recuperation du buffer voisin E
      IF( voisin(E) /= -1 ) THEN
!
         DO k = sz, ez
            DO j = sy, ey
               utabE(j,k) = u(ex,j,k)
            END DO
         END DO
!
      END IF
!
!Recuperation du buffer voisin S
      IF( voisin(S) /= -1 ) THEN
!
         DO k = sz, ez
            DO i = sx, ex
               utabS(i,k) = u(i,sy,k)
            END DO
         END DO
!
      END IF
!
!Recuperation du buffer voisin W
      IF( voisin(W) /= -1 ) THEN
!
         DO k = sz, ez
            DO j = sy, ey
               utabW(j,k) = u(sx,j,k)
            END DO
         END DO
!
      END IF
!
!Recuperation du buffer voisin AV
      IF( voisin(AV) /= -1 ) THEN
!
         DO j = sy, ey
            DO i = sx, ex
               utabAV(i,j) = u(i,j,ez)
            END DO
         END DO
!
      END IF
!
!Recuperation du buffer voisin AR
      IF( voisin(AR) /= -1 ) THEN
!
         DO j = sy, ey
            DO i = sx, ex
               utabAR(i,j) = u(i,j,sz)
             END DO
         END DO
!
      END IF
!
!Barriere de synchronisation avant lecture chez les voisins
!
!$OMP BARRIER
!
!Recuperation du buffer voisin N
      IF( voisin(N) /= -1 ) THEN
!
         DO k = sz, ez
            DO i = sx, ex
               u(i,ey+1,k) = rutabN(i,k)
            END DO
         END DO
!
      END IF
!
!Recuperation du buffer voisin E
      IF( voisin(E) /= -1 ) THEN
!
         DO k = sz, ez
            DO j = sy, ey
               u(ex+1,j,k) = rutabE(j,k)
            END DO
         END DO
!
      END IF
!
!Recuperation du buffer voisin S
      IF( voisin(S) /= -1 ) THEN
!
         DO k = sz, ez
            DO i = sx, ex
               u(i,sy-1,k) = rutabS(i,k)
            END DO
         END DO
!
      END IF
!
!Recuperation du buffer voisin W
      IF( voisin(W) /= -1 ) THEN
!
         DO k = sz, ez
            DO j = sy, ey
               u(sx-1,j,k) = rutabW(j,k)
               i = i + 1
            END DO
         END DO
!
      END IF
!
!Recuperation du buffer voisin AV
      IF( voisin(AV) /= -1 ) THEN
!
         DO j = sy, ey
            DO i = sx, ex
               u(i,j,ez+1) = rutabAV(i,j)
            END DO
         END DO
!
      END IF
!
!Recuperation du buffer voisin AR
      IF( voisin(AR) /= -1 ) THEN
!
         DO j = sy, ey
            DO i = sx, ex
               u(i,j,sz-1) = rutabAR(i,j)
             END DO
         END DO
!
      END IF
!
      RETURN
      END  SUBROUTINE  u_comm
